System.usbDiskModeActivate();


white = Color.new(255,255,255,255);
black = Color.new(0,0,0,255);
grey = Color.new(70,70,70,255);

Enemy = {};
Attack = {};
Counter = {};
Menu_Select = {};



for i = 1,#Player+#NPC+5 do
	Counter[i] = {num = 0, checkT = false};
end

function Get_Old_Stuff()
	oldx = Player[1].x;
	oldy = Player[1].y;
	oldBufferV1 = BufferV1;
	oldBufferV2 = BufferV2;
	oldBufferH1 = BufferH1;
	oldBufferH2 = BufferH2;
	oldTileX = TileX;
	oldTileY = TileY;
	oldpad = pad;
	for i = 1,#NPC do
		NPC[i].oldx = NPC[i].x;
		NPC[i].oldy = NPC[i].y;
		NPC[i].OldCurrentX = NPC[i].CurrentX;
		NPC[i].OldCurrentY = NPC[i].CurrentY;
	end
end



-----------------------------------------------------------
--------------------Tile and Map Engine--------------------
-----------------------------------------------------------

function Screen_Moving()
	if SMoveR then
		Counter[2].num = Counter[2].num + 2;
		
		if Counter[2].num == 2 then
			BufferH1 = BufferH1 + 1;
			BufferH2 = BufferH2 + 1;
		end
		
		if math.mod(Counter[2].num,4) == 2 then
			TileX = TileX - 4;
		end
		
		if Counter[2].num >= 2 and Counter[2].num <= 30 and math.mod(Counter[2].num,4) == 2 then
			if NPC[1] then
				for i = 1,#NPC do
					NPC[i].x = NPC[i].x - 4
				end
			end
		end

		if Counter[2].num == 32 then
			SMoveR = false;
			Counter[2].num = 0;
		end
	end

	if SMoveL then
		Counter[2].num = Counter[2].num + 2;


		if Counter[2].num == 2 then
			BufferH1 = BufferH1 - 1;
			BufferH2 = BufferH2 - 1;
		end
		
		if math.mod(Counter[2].num,4) == 2 then
			TileX = TileX + 4;
		end
		
		if Counter[2].num >= 2 and Counter[2].num <= 30 and math.mod(Counter[2].num,4) == 2 then
			if NPC[1] then
				for i = 1,#NPC do
					NPC[i].x = NPC[i].x + 4
				end
			end
		end

		if Counter[2].num == 32 then
			SMoveL = false;
			Counter[2].num = 0;
		end
	end
	
	if SMoveU then
		Counter[2].num = Counter[2].num + 2;


		if Counter[2].num == 2 then
			BufferV1 = BufferV1 - 1;
			BufferV2 = BufferV2 - 1;
		end

		if math.mod(Counter[2].num,4) == 2 then
			TileY = TileY + 4;
		end
		
		if Counter[2].num >= 2 and Counter[2].num <= 30 and math.mod(Counter[2].num,4) == 2 then
			if NPC[1] then
				for i = 1,#NPC do
					NPC[i].y = NPC[i].y + 4
				end
			end
		end

		if Counter[2].num == 32 then
			SMoveU = false;
			Counter[2].num = 0;
		end
	end

	if SMoveD then
		Counter[2].num = Counter[2].num + 2;


		if Counter[2].num == 2 then
			BufferV1 = BufferV1 + 1;
			BufferV2 = BufferV2 + 1;
		end

		if math.mod(Counter[2].num,4) == 2 then
			TileY = TileY - 4;
		end
		
		if Counter[2].num >= 2 and Counter[2].num <= 30 and math.mod(Counter[2].num,4) == 2 then
			if NPC[1] then
				for i = 1,#NPC do
					NPC[i].y = NPC[i].y - 4
				end
			end
		end

		if Counter[2].num == 32 then
			SMoveD = false;
			Counter[2].num = 0;
		end
	end
end


function Do_Collision()
	local cur1x = math.ceil(9 + (TileX / -32));
	local cur1y = math.ceil(6  + (TileY / -32));
	local cur2x = math.floor(9 + (TileX / -32));
	local cur2y = math.floor(6  + (TileY / -32));
	
	
	for i = 1,#tiles do
		if tiles[i].Collision then
			if Current_Map[cur1y][cur1x] == i or Current_Map[cur2y][cur2x] == i then
				BufferV1 = oldBufferV1;
				BufferV2 = oldBufferV2;
				BufferH1 = oldBufferH1;
				BufferH2 = oldBufferH2;
				TileX = oldTileX;
				TileY = oldTileY;
				for j = 1,#NPC do
					NPC[j].x = NPC[j].oldx
					NPC[j].y = NPC[j].oldy
				end
			end
		end
	end
end


function Make_Door(setTile, setArea, setGoToMap, setTileX, setTileY)
	local cur1x = math.ceil(9 + (TileX / -32));
	local cur1y = math.ceil(6  + (TileY / -32));
	local cur2x = math.floor(9 + (TileX / -32));
	local cur2y = math.floor(6  + (TileY / -32));
	
	
	if Current_Map[cur1y][cur1x] == setTile or Current_Map[cur2y][cur2x] == setTile then
		if Counter[2].num == 30 then
			GameState = setArea;
			Current_Map = setGoToMap;	
			BufferV1 = (setTileY/-32) + 1;
			BufferV2 = ((setTileY/-32) + 1) + 10;

			BufferH1 = (setTileX/-32) + 1;
			BufferH2 = ((setTileX/-32) + 1) + 16;
						
			TileX = setTileX
			TileY = setTileY
		end
	end
end


function Contols_Screen()
	if Player[1].turn == "Nil" then
		if pad:up() and not pad:left() and not pad:right() and not Disable_Movement and
		not WalkL and not WalkR and not WalkD then
			WalkU = true;
		end

		if pad:down() and not pad:left() and not pad:right() and not Disable_Movement and
		not WalkL and not WalkU and not WalkR then
			WalkD = true;
		end

		if pad:left() and not pad:down() and not pad:up() and not Disable_Movement and
		not WalkR and not WalkU and not WalkD then
			WalkL = true;
		end

		if pad:right() and not pad:down() and not pad:up() and not Disable_Movement and
		not WalkL and not WalkU and not WalkD then
			WalkR = true;
		end
	end
	
	
	------------------------------------
	----------------Menu----------------
	------------------------------------
	if Player[1].turn == "Nil" and pad:triangle() and not oldpad:triangle() then
		Menu_Sound:play();
		Player[1].turn = "Menu";
		MenuSelect = 1;
	elseif Player[1].turn == "Menu" and pad:triangle() and not oldpad:triangle() then
		Menu_Sound:play();
		Player[1].turn = "Nil";
	end
	
	if Player[1].turn == "Menu" then
		Image.blit(10,10,Menu_Img)
		local Menu = {};
		Menu[1] = {txt = "Items", x = 346,y = 14 + (20 * 1)};
		Menu[2] = {txt = "Magic", x = 346,y = 14 + (20 * 2)};
		Menu[3] = {txt = "Equipment", x = 346,y = 14 + (20 * 3)};
		Menu[4] = {txt = "Status", x = 346,y = 14 + (20 * 4)};
		Menu[5] = {txt = "Save", x = 346,y = 14 + (20 * 5)};
		for i = 1, #Menu do
			screen.print(Menu[i].x,Menu[i].y,Menu[i].txt,1,white,0);
		end
		for i = 1, #Menu do
			if MenuSelect == i then
				Image.blit(Menu[i].x - (Image.width(Cur) + 5),(Menu[i].y - 20),Cur);
			end
		end
		if MenuSelect > #Menu then
			MenuSelect = 1
		end
		if MenuSelect == 0 then
			MenuSelect = #Menu
		end
		if pad:up() and not oldpad:up() then
			Menu_Sound:play();
			MenuSelect = MenuSelect - 1
		end
		if pad:down() and not oldpad:down() then
			Menu_Sound:play();
			MenuSelect = MenuSelect + 1
		end
	end
	------------------------------------
	--------------Menu End--------------
	------------------------------------
	
	
	
	
	if WalkR == true then
		Counter[1].num = Counter[1].num + 2;

		if Counter[1].num >= 2 and Counter[1].num <= 16 then
			Player[1].img = Player[1].Right2;
		end
			
		if Counter[1].num == 2 then
			SMoveR = true;
		end

		if Counter[1].num >= 18 and Counter[1].num <= 30 then
			Player[1].img = Player[1].Right1;
		end

		if Counter[1].num == 32 then
			Counter[1].num = 0;
			WalkR = false;
			Random_Battles = math.floor(math.random(1,MaxRandom_Battle));
		end
	end

		
	if WalkL == true then
		Counter[1].num = Counter[1].num + 2;

		if Counter[1].num >= 2 and Counter[1].num <= 16 then
			Player[1].img = Player[1].Left2;
		end
			
		if Counter[1].num == 2 then
			SMoveL = true;
		end

		if Counter[1].num >= 18 and Counter[1].num <= 30 then
			Player[1].img = Player[1].Left1;
		end

		if Counter[1].num == 32 then
			Counter[1].num = 0;
			WalkL = false;
			Random_Battles = math.floor(math.random(1,MaxRandom_Battle));
		end
	end
		

	if WalkU == true then
		Counter[1].num = Counter[1].num + 2;

		if Counter[1].num >= 2 and Counter[1].num <= 16 then
			Player[1].img = Player[1].Up2;
		end
			
		if Counter[1].num == 2 then
			SMoveU = true;
		end

		if Counter[1].num >= 18 and Counter[1].num <= 30 then
			Player[1].img = Player[1].Up1;
		end

		if Counter[1].num == 32 then
			Counter[1].num = 0;
			WalkU = false;
			Random_Battles = math.floor(math.random(1,MaxRandom_Battle));
		end
	end


	if WalkD == true then
		Counter[1].num = Counter[1].num + 2;

		if Counter[1].num >= 2 and Counter[1].num <= 16 then
			Player[1].img = Player[1].Down2;
		end

		if Counter[1].num == 2 then
			SMoveD = true;
		end

		if Counter[1].num >= 18 and Counter[1].num <= 30 then
			Player[1].img = Player[1].Down1;
		end

		if Counter[1].num == 32 then
			Counter[1].num = 0;
			WalkD = false;
			Random_Battles = math.floor(math.random(1,MaxRandom_Battle));
		end
	end
end


function Battle_Area()
	local cur1x = math.ceil(9 + (TileX / -32));
	local cur1y = math.ceil(6  + (TileY / -32));
	local cur2x = math.floor(9 + (TileX / -32));
	local cur2y = math.floor(6  + (TileY / -32));
	
	if Random_Battles == math.floor(MaxRandom_Battle/2) then
		GameState = "Load_Battle";
		Disable_Movement = true;
	end
	
	for i = 1,#tiles do
		if Current_Map[cur1y][cur1x] == i or Current_Map[cur2y][cur2x] == i then
			if tiles[i].MaxRandom_Battle then
				MaxRandom_Battle = tiles[i].MaxRandom_Battle
			end
			if tiles[i].MaxEnemies then
				MaxEnemies = tiles[i].MaxEnemies
			end
			if tiles[i].ThisEnemy then
				ThisEnemy = tiles[i].ThisEnemy
			end
			if tiles[i].ThatEnemy then
				ThatEnemy = tiles[i].ThatEnemy
			end
		end
	end
end


function Draw_Layer_1()
	for V = BufferV1,BufferV2 do
		for H = BufferH1,BufferH2 do
			local x = (H - 2) * 32 + TileX;
			local y = (V - 2) * 32 + TileY;
			Image.blit(x,y, tiles[Current_Map[V][H]].img);
		end
	end
end


function DeInti_Battle()
	repeat
		table.remove(Attack);
		table.remove(Enemy);
		table.remove(Menu_Select);
	until #Attack == 0 and #Enemy == 0 and #Menu_Select == 0;
	for i = 1, #Player do
		Player[i].turn = "Nil";
		Counter[i].num = 0;
		Counter[i].checkT = false;
	end
	if #Player > 1 then
		for i = 2, #Player do
			Player[i].x = 300;
			Player[i].y = Player[i - 1].y + 28;
			Player[i].img = Player[i].Stand;
		end
	end
	Player[1].img = Player[1].Down1;
	Player[1].x = 224;
	Player[1].y = 128;
	Player[1].turn = "Nil"
	Disable_Movement = false;
	Total_Money = 0;
	Total_EXP = 0;
end



-----------------------------------------------------------
----------------------Battle Engine------------------------
-----------------------------------------------------------

function Battle_System()
	for i = 1,#Enemy do
		if Enemy[i] then
			Image.blit(Enemy[i].x, Enemy[i].y, Enemy[i].img);
			if Enemy[i].hp < 0 then
				table.remove(Enemy,i);
			end
		end
	end
	
	for setPlayer = 1,#Player do
		local Enemy_Attack;
		Image.blit(Player[setPlayer].x,Player[setPlayer].y,Player[setPlayer].img);

		if Player[setPlayer].status == "Dead" then
			Player[setPlayer].img = Player[setPlayer].Fallen
			Player[setPlayer].hp = 0;
		end
		
		
		if Player[setPlayer].turn ~= "Nil" and Player[setPlayer].turn ~= "Lose" and Player[setPlayer].turn ~= "Win1" and 
		Player[setPlayer].turn ~= "Win2" and Player[setPlayer].turn ~= "Win3"then
			for i = 1, #Menu[setPlayer] do
				screen.print(Menu[setPlayer][i].x + 32,Menu[setPlayer][i].y + 16,Menu[setPlayer][i].txt,.8,white,black);
				screen.print(Menu[setPlayer][i].x + 32,Menu[setPlayer][i].y + 16,Menu[setPlayer][i].txt,.8,white,black);
				screen.print(Menu[setPlayer][i].x + 32,Menu[setPlayer][i].y + 16,Menu[setPlayer][i].txt,.8,white,black);
				screen.print(Menu[setPlayer][i].x + 32,Menu[setPlayer][i].y + 16,Menu[setPlayer][i].txt,.8,white,black);
			end
		end
		screen.print(430,18 + (setPlayer*56), Player[setPlayer].hp,.8,white,0);
		
		
		if Player[setPlayer].turn == "Option" then
			if Menu_Select[setPlayer].foo == #Menu[setPlayer] + 1 then
				Menu_Select[setPlayer].foo = 1;
			end

			if Menu_Select[setPlayer].foo == #Menu[setPlayer] - #Menu[setPlayer] then
				Menu_Select[setPlayer].foo = #Menu[setPlayer];
			end

			for i = 1, #Menu[setPlayer] do
				if Menu_Select[setPlayer].foo == i then
					Image.blit(Menu[setPlayer][i].x,Menu[setPlayer][i].y,Cur);
				end
			end
		end


		if Player[setPlayer].turn == "Attack_Choose" then
			if Menu_Select[setPlayer].foo == #Enemy + 1 then
				Menu_Select[setPlayer].foo = 1;
			end

			if Menu_Select[setPlayer].foo == #Enemy - #Enemy then
				Menu_Select[setPlayer].foo = #Enemy;
			end

			Image.blit(
			Enemy[Menu_Select[setPlayer].foo].x - Image.height(Enemy[Menu_Select[setPlayer].foo].img) - 10,
			Enemy[Menu_Select[setPlayer].foo].y,
			Cur
			)
		end
		
		
		
		if Player[1].turn == "Win2" then
			Image.blit(40,0,Info_Img);
			screen.print(250,20,Total_EXP,.8,white,0);
			screen.print(100,20,"You've Obtained       exp",.8,white,black);
		end
		if Player[1].turn == "Win1" then
			Image.blit(40,0,Info_Img);
			screen.print(230,20,Total_Money,.8,white,0);
			screen.print(100,20,"You've Earned      gil",.8,white,black);
		end

		
		
		if pad:circle() and not oldpad:circle() then	
			if Player[setPlayer].turn == "Win2" then
				Menu_Sound:play();
				GameState = "Load_Overworld";
				if Player[setPlayer].status ~= "Dead" then
					Player[setPlayer].exp = Player[setPlayer].exp + Total_EXP;
				end
			end
			if Player[setPlayer].turn == "Win1" then
				Menu_Sound:play();
				Player[setPlayer].turn = "Win2";
				Player[setPlayer].gil = Player[setPlayer].gil + Total_Money;
			end

			if Player[setPlayer].turn == "Attack_Choose" then
				Menu_Sound:play();
				Player[setPlayer].turn = "Nil";
				Attack[Menu_Select[setPlayer].foo][setPlayer].foo = true;
				Counter[setPlayer].checkT = true;
				Menu[setPlayer][1].Opt = true;
			end

			if Player[setPlayer].turn == "Option" then
				if Menu_Select[setPlayer].foo == 1 then
					Player[setPlayer].turn = "Attack_Choose";
					Menu_Sound:play();
				end
			end
		end


		if pad:cross() and not oldpad:cross() then
			if Player[setPlayer].turn == "Attack_Choose" then
				Menu_Sound:play();
				Player[setPlayer].turn = "Option";
				Menu_Select[setPlayer].foo = 1;
			end
		end
	
	

		if pad:up() and not oldpad:up() then
			if Player[setPlayer].turn == "Attack_Choose" 
			or Player[setPlayer].turn == "Option" then
				Menu_Sound:play();
				Menu_Select[setPlayer].foo = Menu_Select[setPlayer].foo - 1;
			end
		end

		if pad:down() and not oldpad:down() then
			if Player[setPlayer].turn == "Attack_Choose"
			or Player[setPlayer].turn == "Option" then
				Menu_Sound:play();
				Menu_Select[setPlayer].foo = Menu_Select[setPlayer].foo + 1;
			end
		end
		
		
		
		if #Enemy == 0 and Counter[setPlayer].num < 995 then
			Player[setPlayer].turn = "Win1";
			Counter[setPlayer].checkT = true;
			Counter[setPlayer].num = 995;
			if Player[setPlayer].status == "Dead" then
				Counter[setPlayer].checkT = false;
			end
		end

		if pad:r() and not oldpad:r() then
			GameState = "Load_Overworld";
		end

		
---------------------------------------------------------------------
		if Counter[setPlayer].checkT == true then
			Counter[setPlayer].num = Counter[setPlayer].num + 1;
		end
		
		if Counter[setPlayer].num ==5 and Player[setPlayer].status == "Dead" then

			if setPlayer < #Player then
				Counter[setPlayer + 1].checkT = true;
			end

			if setPlayer == #Player then
				Counter[1].checkT = true;
				Counter[1].num = 55;
			end
			
			Counter[setPlayer].checkT = false;
			Counter[setPlayer].num = 0;
		elseif Counter[setPlayer].num ==5 then
			Player[setPlayer].x = 298;
			Player[setPlayer].img = Player[setPlayer].Walk;
		end

		if Counter[setPlayer].num ==10 then
			Player[setPlayer].x = 296;
			Player[setPlayer].img = Player[setPlayer].Stand;
		end

		if Counter[setPlayer].num ==15 then
			Player[setPlayer].x = 294;
			Player[setPlayer].img = Player[setPlayer].Walk;
		end

		if Counter[setPlayer].num ==20 then
			Player[setPlayer].turn = "Option";
			Player[setPlayer].x = 292;
			Player[setPlayer].img = Player[setPlayer].Walk;
		end

		if Counter[setPlayer].num ==25 then
			Counter[setPlayer].checkT = false;
			Player[setPlayer].x = 290;
			Player[setPlayer].img = Player[setPlayer].Stand;
		end

------------------------------------------
		if Counter[setPlayer].num==30 then
			Player[setPlayer].x = 290;
			Player[setPlayer].img = Player[setPlayer].Walk;
		end

		if Counter[setPlayer].num==35 then
			Player[setPlayer].x = 292;
			Player[setPlayer].img = Player[setPlayer].Stand;
		end

		if Counter[setPlayer].num==40 then
			Player[setPlayer].x = 294;
			Player[setPlayer].img = Player[setPlayer].Walk;
		end

		if Counter[setPlayer].num==45 then
			Player[setPlayer].img = Player[setPlayer].Stand;
			Player[setPlayer].x = 296;
		end

		if Counter[setPlayer].num==50 then
			Player[setPlayer].x = 298;
			Player[setPlayer].img = Player[setPlayer].Walk;
		end

		
		if Counter[setPlayer].num==55 then
			if setPlayer < #Player then
				Counter[setPlayer + 1].checkT = true;
			end

			if setPlayer == #Player then
				Counter[1].checkT = true;
				Counter[1].num = 55;
			end
				
			Counter[setPlayer].checkT = false;
			Counter[setPlayer].num = 0;
			Player[setPlayer].x = 300;
			Player[setPlayer].img = Player[setPlayer].Stand;
		end


---------------------------------------------------------------------------------------
		if Counter[setPlayer].num == 60 and Player[setPlayer].status == "Dead" then
			Counter[setPlayer].checkT = false;
			Counter[setPlayer].num = 0;
			if setPlayer < #Player then
				Counter[setPlayer + 1].checkT = true;
				Counter[setPlayer + 1].num = 55;
			end
			if setPlayer == #Player then
				Counter[1].checkT = true;
			end
		end
		
		
		if Counter[setPlayer].num == 65 then
			Player[setPlayer].x = 298;
			Player[setPlayer].img = Player[setPlayer].Walk;
		end
			

		if Counter[setPlayer].num == 70 then
			Player[setPlayer].x = 296;
			Player[setPlayer].img = Player[setPlayer].Stand;
		end

		
		if Counter[setPlayer].num == 75 then
			Player[setPlayer].x = 294;
			Player[setPlayer].img = Player[setPlayer].Walk;
		end


		if Counter[setPlayer].num == 80 then
			Player[setPlayer].x = 292;
			Player[setPlayer].img = Player[setPlayer].Stand;
		end


		
		
		
		
		
		
		if Counter[setPlayer].num == 90 and Menu[setPlayer][1].Opt == true then
			if Enemy[Menu_Select[setPlayer].foo] == nil then
				Menu_Select[setPlayer].foo = 1;
			end
				
			Enemy[Menu_Select[setPlayer].foo].x = Enemy[Menu_Select[setPlayer].foo].x + 3;
			Player[setPlayer].img = Player[setPlayer].Attack_1;
		end


		if Counter[setPlayer].num == 95 and Menu[setPlayer][1].Opt == true then
			Enemy[Menu_Select[setPlayer].foo].x = Enemy[Menu_Select[setPlayer].foo].x - 3;
			Sword_Sound:play();
			Player[setPlayer].img = Player[setPlayer].Attack_2;
		end


		if Counter[setPlayer].num == 100 and Menu[setPlayer][1].Opt == true then
			Enemy[Menu_Select[setPlayer].foo].x = Enemy[Menu_Select[setPlayer].foo].x + 3;
			Player[setPlayer].img = Player[setPlayer].Attack_1;
		end


		if Counter[setPlayer].num == 105 and Menu[setPlayer][1].Opt == true then
			Sword_Sound:play()
			Player[setPlayer].img = Player[setPlayer].Attack_2;
			Enemy[Menu_Select[setPlayer].foo].x = Enemy[Menu_Select[setPlayer].foo].x - 3;
			Enemy[Menu_Select[setPlayer].foo].hp = Enemy[Menu_Select[setPlayer].foo].hp - 
			(Player[setPlayer].str - Enemy[Menu_Select[setPlayer].foo].def);
		end
		
		
		
		
		
		
		
		
		if Counter[setPlayer].num==110 then
			Player[setPlayer].x = 290;
			Player[setPlayer].img = Player[setPlayer].Walk;
		end

		if Counter[setPlayer].num==115 then
			Player[setPlayer].x = 292;
			Player[setPlayer].img = Player[setPlayer].Stand;
		end

		if Counter[setPlayer].num==120 then
			Player[setPlayer].x = 294;
			Player[setPlayer].img = Player[setPlayer].Walk;
		end

		if Counter[setPlayer].num==125 then
			Player[setPlayer].img = Player[setPlayer].Stand;
			Player[setPlayer].x = 296;
		end

		if Counter[setPlayer].num==130 then
			Player[setPlayer].x = 298;
			Player[setPlayer].img = Player[setPlayer].Walk;
		end

		if Counter[setPlayer].num==135 then
			Player[setPlayer].x = 300;
			Player[setPlayer].img = Player[setPlayer].Stand;
		end
		
		
		if Counter[setPlayer].num ==140 then
			Menu_Select[setPlayer].foo = 1;
			Counter[setPlayer].checkT = false;
			Counter[setPlayer].num = 0;
			Menu[setPlayer][1].Opt = false;
			Menu[setPlayer][2].Opt = false;
			Menu[setPlayer][3].Opt = false;
			Menu[setPlayer][4].Opt = false;
			Attack[Menu_Select[setPlayer].foo][setPlayer].foo = false;
			if setPlayer < #Player then
				Counter[setPlayer + 1].checkT = true;
				Counter[setPlayer + 1].num = 55;
			end

			if setPlayer == #Player then
				Counter[1].checkT = true;
			end
		end

		
		if Counter[setPlayer].num == 1000 then
			Player[setPlayer].img = Player[setPlayer].Fanfare;
		end
		
		if Counter[setPlayer].num == 1030 then
			Player[setPlayer].img = Player[setPlayer].Stand;
			Counter[setPlayer].num = 995;
		end
	end
end	
	

function Inti_Battle()
	Create_Enemy();
	for i = 1,#Enemy do
		Attack[i] = {};
		for j = 1,#Player do
			Attack[i][j] = {foo = false};
			Menu_Select[j] = {foo = 1};
		end
	end
	GameState = "Battle";
	Counter[1].num = 0;
	Counter[1].checkT = true;
	Random_Battles = 0;
	Player[1].img = Player[1].Stand;
	Player[1].x = 300;
	Player[1].y = 60;
end



function Draw_Battle(Area)
	Image.blit(0,0,BG);
	Image.blit(38,20,Area);
	Image.blit(136,20,Area);
	Image.blit(268,20,Area);
end



function Create_Enemy()
	local foo = math.floor(math.random(1,1+MaxEnemies));
	for i = 1, foo do
		local bar = math.floor(math.random(ThisEnemy,1+ThatEnemy));
		local x = 54;
		local y = i;
		
		if i > 3 then
			x = x + (Image.width(Enemies[bar].img) + 10);
			y = i - 3;
		end
		
			Enemy[i] = 
		{
			img = Enemies[bar].img,
			x = x,
			y = 34 + (y * Image.height(Enemies[bar].img)) - 1,

			hp = Enemies[bar].hp,
			mp = Enemies[bar].mp,
			str = Enemies[bar].str,
			def = Enemies[bar].def,
			spd = Enemies[bar].spd,
			int = Enemies[bar].int,
			gold = Enemies[bar].gold,
			exp = Enemies[bar].exp,
		}
	end
	for i = 1, #Enemy do
		Total_Money = Total_Money + Enemy[i].gold
		Total_EXP = Total_EXP + Enemy[i].exp
	end
end




-----------------------------------------------------------
---------------------NPC/Shop Engine-----------------------
-----------------------------------------------------------
function NPC_Do(NPC_Num)
	local Random_Num = math.ceil(math.random(0,400));
	
	if Random_Num == 100 and not NPC[NPC_Num].MoveR
	and not NPC[NPC_Num].MoveL and not NPC[NPC_Num].MoveU and not NPC[NPC_Num].MoveD then
		NPC[NPC_Num].MoveR = true;
		NPC[NPC_Num].CurrentX = NPC[NPC_Num].CurrentX + 1;
	elseif Random_Num == 200 and not NPC[NPC_Num].MoveR 
	and not NPC[NPC_Num].MoveL and not NPC[NPC_Num].MoveU and not NPC[NPC_Num].MoveD then
		NPC[NPC_Num].MoveL = true;
		NPC[NPC_Num].CurrentX = NPC[NPC_Num].CurrentX - 1;
	elseif Random_Num == 300 and not NPC[NPC_Num].MoveR 
	and not NPC[NPC_Num].MoveL and not NPC[NPC_Num].MoveU and not NPC[NPC_Num].MoveD then
		NPC[NPC_Num].MoveU = true;
		NPC[NPC_Num].CurrentY = NPC[NPC_Num].CurrentY - 1;
	elseif Random_Num == 400 and not NPC[NPC_Num].MoveR 
	and not NPC[NPC_Num].MoveL and not NPC[NPC_Num].MoveU and not NPC[NPC_Num].MoveD then
		NPC[NPC_Num].MoveD = true;
		NPC[NPC_Num].CurrentY = NPC[NPC_Num].CurrentY + 1;
	end
	
	
	for b = 3, #NPC[NPC_Num], 3 do
		if (Player[1].x + Image.width(Player[1].img) + 1 > NPC[NPC_Num].x) and 
		(Player[1].x < NPC[NPC_Num].x + Image.width(NPC[NPC_Num].img) + 1) and
		(Player[1].y + Image.height(Player[1].img) > NPC[NPC_Num].y) and
		(Player[1].y < NPC[NPC_Num].y + Image.height(NPC[NPC_Num].img)) then
			if pad:circle() and not oldpad:circle() and not WalkR and 
			not WalkL and not WalkU and not WalkD and not NPC[NPC_Num].MoveL 
			and not NPC[NPC_Num].MoveR and not NPC[NPC_Num].MoveU and not NPC[NPC_Num].MoveD then
				if Player[1].turn == "Nil" then
					Player[1].turn = "Dialogue"..NPC_Num..b/3;
				elseif Player[1].turn == "Dialogue"..NPC_Num..b/3 then
					Player[1].turn = "Nil";
				end
			end
		end
		
		if (Player[1].x + Image.width(Player[1].img) > NPC[NPC_Num].x) and 
		(Player[1].x < NPC[NPC_Num].x + Image.width(NPC[NPC_Num].img)) and
		(Player[1].y + Image.height(Player[1].img) + 1 > NPC[NPC_Num].y) and
		(Player[1].y  < NPC[NPC_Num].y + Image.height(NPC[NPC_Num].img) + 1) then
			if pad:circle() and not oldpad:circle() and not WalkR and 
			not WalkL and not WalkU and not WalkD and not NPC[NPC_Num].MoveL 
			and not NPC[NPC_Num].MoveR and not NPC[NPC_Num].MoveU and not NPC[NPC_Num].MoveD then
				if Player[1].turn == "Nil" then
					Player[1].turn = "Dialogue"..NPC_Num..b/3;
				elseif Player[1].turn == "Dialogue"..NPC_Num..b/3 then
					Player[1].turn = "Nil";
				end
			end
		end
		
		if (Player[1].x + Image.width(Player[1].img) - 1 > NPC[NPC_Num].x) and 
		(Player[1].x < NPC[NPC_Num].x + Image.width(NPC[NPC_Num].img) - 1) and
		(Player[1].y + Image.height(Player[1].img) - 1 > NPC[NPC_Num].y) and
		(Player[1].y < NPC[NPC_Num].y + Image.height(NPC[NPC_Num].img) - 1) then
			if pad:circle() and not oldpad:circle() and not WalkR and 
			not WalkL and not WalkU and not WalkD and not NPC[NPC_Num].MoveL 
			and not NPC[NPC_Num].MoveR and not NPC[NPC_Num].MoveU and not NPC[NPC_Num].MoveD then
				if Player[1].turn == "Nil" then
					Player[1].turn = "Dialogue"..NPC_Num..b/3;
				elseif Player[1].turn == "Dialogue"..NPC_Num..b/3 then
					Player[1].turn = "Nil";
				end
			end
		end
		
		
		if Player[1].turn == "Dialogue"..NPC_Num..b/3 then
			Image.blit(10,200,Txt_Box);
			local Position_Text = 0;
			for h = b-2, b do
				if math.mod(h,3) == 1 then
					Position_Text = 1;
				end
				if math.mod(h,3) == 2 then
					Position_Text = 2;
				end
				if math.mod(h,3) == 3 then
					Position_Text = 3;
				end
				screen.print(22,200 + (Position_Text*20), NPC[NPC_Num][h],.8,white,0);
				NPC[NPC_Num].CurrentX = NPC[NPC_Num].OldCurrentX;
				NPC[NPC_Num].CurrentY = NPC[NPC_Num].OldCurrentY;
				Random_Num = 0;
				NPC[NPC_Num].MoveU = false;
				NPC[NPC_Num].MoveD = false;
				NPC[NPC_Num].MoveR = false;
				NPC[NPC_Num].MoveL = false;
				Counter[NPC_Num+2].num = 0;
			end
		end
	end
	
	
	for i = 1,#tiles do
		if tiles[i].Collision or tiles[i].NPC_Collision then
			if Current_Map[NPC[NPC_Num].CurrentY][NPC[NPC_Num].CurrentX] == i then
				NPC[NPC_Num].MoveU = false;
				NPC[NPC_Num].MoveD = false;
				NPC[NPC_Num].MoveR = false;
				NPC[NPC_Num].MoveL = false;
				NPC[NPC_Num].CurrentX = NPC[NPC_Num].OldCurrentX;
				NPC[NPC_Num].CurrentY = NPC[NPC_Num].OldCurrentY;
			end
		end
	end
	
	if NPC[NPC_Num].MoveL then
		Counter[NPC_Num+2].num = Counter[NPC_Num+2].num + 2;
		
		if math.mod(Counter[NPC_Num+2].num,4) == 2 then
			NPC[NPC_Num].x = NPC[NPC_Num].x - 4;
		end
		
		if Counter[NPC_Num+2].num == 32 then
			Counter[NPC_Num+2].num = 0;
			NPC[NPC_Num].MoveL = false;
		end
		
	elseif NPC[NPC_Num].MoveR then
		Counter[NPC_Num+2].num = Counter[NPC_Num+2].num + 2;
		
		if math.mod(Counter[NPC_Num+2].num,4) == 2 then
			NPC[NPC_Num].x = NPC[NPC_Num].x + 4;
		end
		
		if Counter[NPC_Num+2].num == 32 then
			Counter[NPC_Num+2].num = 0;
			NPC[NPC_Num].MoveR = false;
		end
		
	elseif NPC[NPC_Num].MoveU then
		Counter[NPC_Num+2].num = Counter[NPC_Num+2].num + 2;
		
		if math.mod(Counter[NPC_Num+2].num,4) == 2 then
			NPC[NPC_Num].y = NPC[NPC_Num].y - 4;
		end
		
		if Counter[NPC_Num+2].num == 32 then
			Counter[NPC_Num+2].num = 0;
			NPC[NPC_Num].MoveU = false;
		end
		
	elseif NPC[NPC_Num].MoveD then
		Counter[NPC_Num+2].num = Counter[NPC_Num+2].num + 2;
		
		if math.mod(Counter[NPC_Num+2].num,4) == 2 then
			NPC[NPC_Num].y = NPC[NPC_Num].y + 4;
		end
		
		if Counter[NPC_Num+2].num == 32 then
			Counter[NPC_Num+2].num = 0;
			NPC[NPC_Num].MoveD = false;
		end
	end
	
	
	Image.blit(NPC[NPC_Num].x,NPC[NPC_Num].y,NPC[NPC_Num].img);
end


function Do_Inn(NPC_Num) 
	if (Player[1].x + Image.width(Player[1].img) > NPC[NPC_Num].x) and 
	(Player[1].x < NPC[NPC_Num].x + Image.width(NPC[NPC_Num].img)) and
	(Player[1].y + Image.height(Player[1].img) > NPC[NPC_Num].y) and
	(Player[1].y  < NPC[NPC_Num].y + Image.height(NPC[NPC_Num].img) + 33) then
		if pad:circle() and not oldpad:circle() and not WalkR and 
		not WalkL and not WalkU and not WalkD then
			if Player[1].turn == "Nil" then
				Player[1].turn = "Inn";
			end
			if Player[1].turn == "Inn" then
				
			end
		end

		if pad:cross() and not oldpad:cross() and not WalkR and 
		not WalkL and not WalkU and not WalkD then
			if Player[1].turn == "Inn" then
				Player[1].turn = "Nil";
			end
		end
	end
	
	if Player[1].turn == "Inn" then
		for b = 3, #NPC[NPC_Num], 3 do
			Image.blit(10,200,Txt_Box);
			local Position_Text = 0;
			for h = b-2, b do
				if math.mod(h,3) == 1 then
					Position_Text = 1;
				end
				if math.mod(h,3) == 2 then
					Position_Text = 2;
				end
				if math.mod(h,3) == 3 then
					Position_Text = 3;
				end
				screen.print(22,200 + (Position_Text*20), NPC[NPC_Num][h],.8,white,0);
			end
		end
	end
	
	Image.blit(NPC[NPC_Num].x,NPC[NPC_Num].y,NPC[NPC_Num].img);
end
