math.randomseed(os.time());
dofile("Data/Scripts/maps.lua");
dofile("Data/Scripts/save.lua");
dofile("Data/Scripts/enemies.lua");
dofile("Data/Scripts/NPC's.lua");
dofile("Data/Scripts/engine.lua");

BG = Image.load("Data/Images/Background.png");
Info_Img = Image.load("Data/Images/info.png");
Plains = Image.load("Data/Images/Field.png");
Cur = Image.load("Data/Images/Cursor.png");
Menu_Img = Image.load("Data/Images/Menu.png");
Txt_Box = Image.load("Data/Images/txt_box.png");
Splash_Screen = Image.load("Data/Images/splashpsp.png");

Menu_Sound = Sound.load("Data/Sounds/Menu.wav");
Sword_Sound = Sound.load("Data/Sounds/Sword.wav");



while true do
Get_Old_Stuff();
pad = Controls.read();
screen.startDraw();
screen.clear(0);


if GameState == "Contest_Splash" then
	Counter[1].num = Counter[1].num + 1
	if Counter[1].num > 0 and  Counter[1].num < 180 then
		Image.blit(0,0,Splash_Screen);
	end

	if Counter[1].num > 180 and Counter[1].num < 280 then
		screen.print(110,136,"The Western Project",1.3,white,black);
	end
	
	if Counter[1].num > 280 then
		GameState = "Load_Overworld";
		Counter[1].num = 0;
	end
end




---------------------------------------
---------------Overworld---------------
---------------------------------------

if GameState == "Load_Overworld" then
	GameState = "Overworld";
	DeInti_Battle();
end

if GameState == "Overworld" then
	Battle_Area();
	Draw_Layer_1();
	Screen_Moving();
	Do_Collision();
	Image.blit(Player[1].x, Player[1].y, Player[1].img);
	Contols_Screen();
	Make_Door(37, "Load_Town_1", Town1, -320, -352);
	Make_Door(58, "Load_Ice_Dungeon", Ice_Dungeon, -128, -64);
end

---------------------------------------
----------------Town 1-----------------
---------------------------------------

--Town Of Debug
if GameState == "Load_Town_1" then
	GameState = "Town_1";
	Player[1].img = Player[1].Up1;
end

if GameState == "Town_1" then
	Draw_Layer_1();
	Screen_Moving();
	Do_Collision();
	NPC_Do(1);
	NPC_Do(2);
	Image.blit(Player[1].x, Player[1].y, Player[1].img);
	Contols_Screen();
	Make_Door(35, "Overworld", world, -320, -224);
	Make_Door(48, "Load_Town_1_Inn", Town1_Inn, -320, -352);
	Make_Door(49, "Load_Town_1_Big_Building", Town1_Big_Building, -320, -224);
end


--The Town Of Debug's Inn
if GameState == "Load_Town_1_Inn" then
	GameState = "Town_1_Inn";
	Player[1].img = Player[1].Up1
end

if GameState == "Town_1_Inn" then
	Draw_Layer_1();
	Screen_Moving();
	Do_Collision();
	Do_Inn(3);
	Image.blit(Player[1].x, Player[1].y, Player[1].img);
	Contols_Screen();
	Make_Door(48, "Town_1", Town1, -128, -320);
end


--The Town Of Debug's "Big Building"
if GameState == "Load_Town_1_Big_Building" then
	GameState = "Town_1_Big_Building";
	Player[1].img = Player[1].Up1
end

if GameState == "Town_1_Big_Building" then
	Draw_Layer_1();
	Screen_Moving();
	Do_Collision();
	Image.blit(Player[1].x, Player[1].y, Player[1].img);
	Contols_Screen();
	Make_Door(48, "Town_1", Town1, -320, -192);
end









if GameState == "Load_Ice_Dungeon" then
	GameState = "Ice_Dungeon";
	Player[1].img = Player[1].Down1
end

if GameState == "Ice_Dungeon" then
	Battle_Area();
	Draw_Layer_1();
	Screen_Moving();
	Do_Collision();
	Image.blit(Player[1].x, Player[1].y, Player[1].img);
	Contols_Screen();
	Make_Door(33, "Overworld", world, -192, -128);
	Make_Door(34, "Game_Over", world, -192, -128);
end




if GameState == "Load_Battle" then
	Inti_Battle();
end

if GameState == "Battle" then
	Draw_Battle(Plains);
	Battle_System();
end

if GameState == "Game_Over" then
	screen.print(110,136,"      Demo Over    ",1.3,white,black);
end

if pad:start() then
	break
end

screen.endDraw();
screen.waitVblankStart();
screen.flipscreen();
oldpad = pad;
end